<template>
  <div
    v-click-away="closeDropdown"
    class="sa-select-daterange"
    :class="invalidRange && 'invalid'"
  >
    <button
      :id="uniqueId"
      ref="button"
      :class="buttonClasses"
      aria-haspopup="true"
      :aria-expanded="dropdownOpen"
      @click="toggleDropdown"
    >
      <span>{{ buttonLabel }}</span>
      <sa-icon icon="chevron-down" />
    </button>
    <div
      v-show="dropdownOpen"
      ref="dropdown"
      class="dropdown"
      :class="align"
      tabindex="-1"
      role="listbox"
      :aria-labelledby="uniqueId"
      @keydown.esc.prevent="closeDropdown"
    >
      <div
        v-if="fieldOptions.length"
        class="field-select"
        data-testid="field-select"
      >
        <label class="label">Field</label>
        <sa-select
          size="small"
          :full-width="true"
          :options="fieldOptions"
          :show-heading="false"
          :initial-selection="[range.field]"
          @change="fieldChanged"
        />
      </div>

      <sa-select-date-range-input
        class="from-select"
        data-testid="from-select"
        size="small"
        label="From"
        :initial-date="range.from"
        @change="fromDateChanged"
      />

      <sa-select-date-range-input
        class="to-select"
        data-testid="to-select"
        size="small"
        label="To"
        :initial-date="range.to"
        @change="toDateChanged"
      />

      <div v-if="invalidRange">
        <sa-caption
          text="'To' date cannot be before 'From' date"
          type="danger"
        />
      </div>
    </div>
  </div>
</template>

<script>
import dayjs from 'dayjs'
import { uniq as _uniq } from 'lodash'

function formatDate(dateString) {
  if (!dateString) {
    return ''
  }
  return dayjs(dateString + 'T12:00:00.000Z').format('D MMM YYYY')
}

export default {
  name: 'SaSelectDateRange',
  props: {
    size: {
      type: String,
      default: 'regular'
    },
    label: {
      type: String,
      default: 'Date Range'
    },
    fields: {
      type: Array,
      default: () => []
    },
    initialRange: {
      type: Object,
      default: () => ({
        field: null,
        from: null,
        to: null
      })
    },
    align: {
      type: String,
      default: 'left'
    }
  },
  data(props) {
    // allow array of strings or { value, label } objects
    const fieldOptions = (props.fields || []).map((field) =>
      typeof field === 'string' ? { value: field, label: field } : field
    )

    const { field, from, to } = props.initialRange
    const range = {
      // default to the first field if none specified
      field: field || (fieldOptions.length > 0 ? fieldOptions[0].value : null),
      from: from || null,
      to: to || null
    }

    return {
      range,
      fieldOptions,
      dropdownOpen: false,
      uniqueId: this.makeUniqueId()
    }
  },
  computed: {
    buttonClasses() {
      const classes = ['select', this.size]
      if (this.hasAllRequiredInputs) {
        classes.push('selected')

        if (this.invalidRange) {
          classes.push('error')
        }
      }
      return classes
    },
    buttonLabel() {
      if (!this.hasAllRequiredInputs) {
        return this.label
      }
      const { range, fieldOptions } = this
      if (fieldOptions.length > 0) {
        const field = fieldOptions.find(({ value }) => value === range.field)
        return field.label
      } else {
        // todo(?): change this to 'From: [date]' or 'To: [date]' when only one present
        return _uniq([range.from, range.to])
          .map(formatDate)
          .join(' - ')
      }
    },
    hasAllRequiredInputs() {
      const { range, fieldOptions: fields } = this
      return (range.from || range.to) && (range.field || fields.length === 0)
    },
    invalidRange() {
      return this.hasAllRequiredInputs && this.range.from > this.range.to
    }
  },
  methods: {
    toggleDropdown() {
      if (!this.dropdownOpen) {
        this.dropdownOpen = true
        setTimeout(() => this.$refs.dropdown.focus())
      } else {
        this.closeDropdown()
      }
    },
    closeDropdown() {
      if (this.dropdownOpen) {
        this.dropdownOpen = false
        this.$refs.button.focus()
      }
    },
    fieldChanged(field) {
      this.rangeChanged({ field: field[0] })
    },
    fromDateChanged(date) {
      this.rangeChanged({ from: date })
    },
    toDateChanged(date) {
      this.rangeChanged({ to: date })
    },
    rangeChanged(change) {
      Object.assign(this.range, change)
      if (!this.invalidRange) {
        this.$emit('change', { ...this.range })
      }
    }
  }
}
</script>

<style lang="scss">
.sa-select-daterange {
  position: relative;

  > .dropdown {
    overflow: visible;
  }
  &.invalid .sa-input-date {
    border-color: color(danger-dark);
    background: color(danger-tint);
  }
}
</style>
